#include <stdio.h>
#include <stdlib.h>
#define   SIZE 20
int main(int argc, char *argv[])
{
    char b1[640];     /* buffer */
    char bb;    /* selected bit */
    char bp;    /* position   */
    char br;    /* oR value   */  
    char d1;    /* read Byte  */
    char d2;    /* write Byte */
    /* bitmap header information */
    unsigned int H1;    /* Length of data plus WAV  header */
    unsigned int H2;    /* offset to header  */
    unsigned int HF;    /* fill              */
    unsigned int HL;    /* length of header  */
    unsigned int HW;    /* Width  in pixels  */
    unsigned int HH;    /* Height in pixels  */
    unsigned int HP;    /* planes (must be 1)*/
    unsigned int HB;    /* bits   per pixel  */
    unsigned int HT;    /* Bytes in image    */
    unsigned int HX;    /* Pixels / metre X  */
    unsigned int HY;    /* Pixels / metre Y  */
    unsigned int HC;    /* Number of colors  */
    /* other internal */
    int iI;    /* loop iteration I  */
    int iJ;    /* loop iteration J  */
    int iK;    /* loop iteration K  */
    float  e1;
    long   fsiz;
    
    FILE *fs;        /* Source */
    FILE *ft;        /* Target */
    
    printf("; EpsonBMP.C - reads  EpsonBMP.bin  captured from a Tektronix THS720A\n");
    printf(";              and writes a standard  EpsonBMP.bmp  file.\n");
    printf(";              Version 1.0, skips over the header and assumes it's a \n"); 
    printf(";              480x640 pixels portait. It outputs in 640x480 Landscape \n");
    printf("               and positive format.                   2013/06/15 R.N.S.\n"); 
    printf("\n"); 
    if ( (fs = fopen("EpsonBMP.bin", "r")) == NULL)   /* r = read, NOT random */
    {
         fprintf(stderr, "Error opening source.\n");
         exit(1);
    }     
    if ( (ft = fopen("EpsonBMP.bmp", "wb")) == NULL)
    {
         fprintf(stderr, "Error opening target.\n");
         exit(1);
    }     
           H1 =  38462;    /* Total file size   */
           H2 =     62;    /* offset to header  */
           HF =      0;    /* filling           */
           HL =     40;    /* length of header  */
           HW =    640;    /* Width  in pixels  */
           HH =    480;    /* Height in pixels  */
           HP =      1;    /* planes (must be 1)*/
           HB =      1;    /* bits   per pixel  */
           HT =  38400;    /* Bytes in image    */
           HX =   2835;    /* Pixels / metre X  */
           HY =   2835;    /* Pixels / metre Y  */
           HC =      2;    /* Number of colors  */
                           
           fprintf(ft, "BM");
           fwrite(&H1, 4, 1, ft);          /* size of file in Bytes */
           fwrite(&HF, 4, 1, ft);          /* 4 nulls           */
           fwrite(&H2, 4, 1, ft);          /* offset to header  */
           fwrite(&HL, 4, 1, ft);          /* length of header  */
           fwrite(&HW, 4, 1, ft);          /* Width  in pixels  */
           fwrite(&HH, 4, 1, ft);          /* Height in pixels  */
           fwrite(&HP, 2, 1, ft);          /* planes (must be 1)*/
           fwrite(&HB, 2, 1, ft);          /* bits   per pixel  */
           fwrite(&HF, 4, 1, ft);          /* compression type  */
           fwrite(&HT, 4, 1, ft);          /* Bytes in image    */
           fwrite(&HX, 4, 1, ft);          /* Pixels / metre X  */
           fwrite(&HY, 4, 1, ft);          /* Pixels / metre Y  */
           fwrite(&HC, 4, 1, ft);          /* Number of colors  */
           fwrite(&HC, 4, 1, ft);          /* Important colours */
           fwrite(&HF, 4, 1, ft);          /* color table black */
           HF = 0xFFFFFFFF;
           fwrite(&HF, 4, 1, ft);          /* color table white */
           HF = 0;
           fseek(fs,   0, SEEK_END);        /* skip to End Of File */
           fsiz = ftell(fs);
           fseek(fs,   0, SEEK_SET);        /* back to Beg Of File */
           printf("  File Size = %ld \n", fsiz);
 
Label1:
           fseek(fs,   4, SEEK_SET);        /* skip the 1B 4A E0 01 meaning 1E0h 480. bytes to come on this line, 8 pixels high */
  /*  outer  loop for 480. Bytes from Source Epson data */
           for (iK = 0; iK < 480; iK++)
               { 
               fseek(fs, 484 - iK, SEEK_SET);
                         
/*  middle loop for top through bottom bytes of Epson data to buffer */
/*  can I assume that caching prevents the hard drive from being read 480 times? */
               for (iJ = 0; iJ < 80; iJ++)
                   {
                   b1[iJ] = fgetc(fs);
                   fseek(fs, 487, SEEK_CUR);  /* 480 - 1 Bytes + 2 ESC sequences */
                   }    
/*  inner loop for 1 Byte of Epson vertical data to 1 Byte of bitmap horizontal data */
               for (iJ = 79; iJ >= 0; iJ--)   /* Flip Bytes vertically */
                   {
                   for (iI = 0; iI < 8; iI++)  /* Flip bits horizontally */
                   /* this is MUCH easier (1 line) in assembler ........ */
                       {
                       bp = ~b1[iJ];         /* Complement and shift */
                       bp = bp >> iI;        /*  shift  */
                       bb = bp & 1;          /*   and   */
                       d2 = d2 | bb;         /*    or   */
                       if (iI < 7)           /* don't do the last shift */
                       d2 = d2 << 1;
                       }
                       putc(d2, ft);
                   }                /* next iI */
               }                        /* next iJ */
           
     if (ftell(fs) < fsiz - 480)
         goto Label1;

     /* I got my results, you fix it         R.N.S.*/

           int fclose(FILE *fs);
           int fclose(FILE *ft);

    /*     printf("  Total Bytes = %d \n", i0);  */
           system("PAUSE");
    return EXIT_SUCCESS;
}
